from requests.api import request
from Crypto.PublicKey.RSA import construct
from Crypto.Cipher import PKCS1_v1_5
import base64
import requests
import string, random
from aiohttp.hdrs import (
    ACCEPT,
    COOKIE,
    PRAGMA,
    REFERER,
    CONNECTION,
    KEEP_ALIVE,
    USER_AGENT,
    CONTENT_TYPE,
    CACHE_CONTROL,
    ACCEPT_ENCODING,
    ACCEPT_LANGUAGE
)
import time
import re

class MR6400:
    def __init__(self, host, username, password):
        self.host = host
        self.username = username
        self.password = password
        self.pubkey = ''
        self.jsessionId = ''
        self.token = ''

        self.parse_macs_hyphens = re.compile('[0-9A-F]{2}-[0-9A-F]{2}-' +
                                             '[0-9A-F]{2}-[0-9A-F]{2}-' +
                                             '[0-9A-F]{2}-[0-9A-F]{2}')
        self.parse_macs_colons = re.compile('[0-9A-F]{2}:[0-9A-F]{2}:' +
                                            '[0-9A-F]{2}:[0-9A-F]{2}:' +
                                            '[0-9A-F]{2}:[0-9A-F]{2}')


    def test(self):
        ee = '010001'
        nn = 'C9977AF1C4B3D4F470FDF091CB6FE19A2DD775CFD77C5F2AF6BB504B8AFB00F3DC94CC997CC0C212308A93273D0392521736AC94079FE43B3A729B051277D89BC4000DFE73D6CA940236AB39C84F08A0AF2F214C3D87F07B9635340B4BAA3A5F60F5497CFECD106AABB8E79B216FEC045EB370CAA11144805BBDE8A2EBA28793'

        try:
            e = int(ee, 16)
            n = int(nn, 16) 
        except ValueError:
            return False

        pubkey = construct((n, e))
        self.pubkey = PKCS1_v1_5.new(pubkey)

        username = self.username.encode('utf-8')
        password = self.password.encode('utf-8')

        b64pass = base64.b64encode(password)
        encryptedUsername = self.pubkey.encrypt(username)
        encryptedPassword = self.pubkey.encrypt(b64pass)

        base16username = base64.b16encode(encryptedUsername).decode('utf-8').lower()
        base16password = base64.b16encode(encryptedPassword).decode('utf-8').lower()

        print(base16username)
        print(base16password)

        # http://192.168.100.254/cgi/login
        # UserName=0c60f2417719644a2d4ea7ac62f6f51a44a83e7aae3c95cbb550fc349b161805be25904f476bdf80f619949b6771a3a01b5c8745a1f121bd93084dd0129770bd132b239f3af846d717f9f83e66f9946973e2a100599cf1305cc87f673b650617fd5cb48ffffb7ebee0841bb15c9ecb03310437905efa00c6c1e0a301dd8eaaee
        # Passwd=60ac4f417fbfe2e78524abd03dbee513c144f931b00f991a1f89124e6bab2a45cb20b0c6bf6836c63fea07633357e70a0805ffd4b6d618784270fd30ee9a00c5865d11a7cc3dcbddebefd97349366e1b51a1729cc00079731e5bf52040f5a6972f0f71d01805b2532443af4c9300880f58c3951290a4334606d702f5b032440e
        # Action=1
        # LoginStatus=0",

    def _get_pub_key(self):
        url = 'http://{}/cgi/getParm'.format(self.host)
        referer = 'http://{}'.format(self.host)
        response = requests.post(url, headers={ 'REFERER': referer})
        if not response.status_code == 200:
            return False

        ee = self._get_field_from_router_response(response.text, 'ee')
        nn = self._get_field_from_router_response(response.text, 'nn')

        try:
            e = int(ee, 16)
            n = int(nn, 16) 
        except ValueError:
            return False

        pubkey = construct((n, e))
        self.pubkey = PKCS1_v1_5.new(pubkey)

        return True

    def _get_field_from_router_response(self, rText, key):
        lines = rText.split('\n')
        for line in lines:
            if (line.startswith('var '+ key)):
                return line.split('=\"')[1].split('\";')[0]
        return ''

    def _get_jsession_id(self):
        username = self.username.encode('utf-8')
        password = self.password.encode('utf-8')

        b64pass = base64.b64encode(password)
        encryptedUsername = self.pubkey.encrypt(username)
        encryptedPassword = self.pubkey.encrypt(b64pass)

        base16username = base64.b16encode(encryptedUsername).decode('utf-8').lower()
        base16password = base64.b16encode(encryptedPassword).decode('utf-8').lower()

        referer = 'http://{}'.format(self.host)
        url = 'http://{}/cgi/login?UserName={}&Passwd={}&Action=1&LoginStatus=0'.format(self.host, base16username, base16password)

        headers= { REFERER: referer }

        response = requests.post(url, headers=headers)

        if not response.status_code == 200:
            print("Error %s from router", response.text)
            return False

        self.jsessionId = dict(response.cookies)['JSESSIONID']
        return True

    def _get_random_alphaNumeric_string(self, stringLength=15):
        lettersAndDigits = string.ascii_letters + string.digits
        return ''.join((random.choice(lettersAndDigits) for i in range(stringLength)))

    def _get_token(self):
        url = 'http://{}/'.format(self.host)
        referer = 'http://{}'.format(self.host)

        headers= {
            REFERER: referer,
            COOKIE: 'loginErrorShow=1; JSESSIONID='+self.jsessionId,
            }

        cookies = {'JSESSIONID': self.jsessionId}
        response = requests.get(url, headers=headers, cookies=cookies)

        if not response.status_code == 200:
            print("Error %s from router", response.text)
            return False

        split = response.text.index('var token=') + len('var token=\"') 
        token = response.text[split:split+30]

        self.token = token
        return True

    def _get_auth_tokens(self):
        print("Retrieving PublicKey...")
        pubkey = self._get_pub_key()
        if not pubkey:
            return False

        print("Retrieving JSessionID...")
        jsessionId = self._get_jsession_id()
        if not jsessionId:
            return False

        print("Retrieving Token...")
        token = self._get_token()
        if not token:
            return False

        return True

    def _get_mac_results(self):
        referer = 'http://{}'.format(self.host)
        headers= {
            'TokenID': self.token,
            REFERER: referer,
            COOKIE: 'JSESSIONID=' + self.jsessionId
            }

        mac_results = []

        # Check both the 2.4GHz and 5GHz client lists.
        for clients_frequency in ('1', '2'):

            # Refresh associated clients.
            page = requests.post(
                'http://{}/cgi?7'.format(self.host),
                headers=headers,
                data=(
                    '[ACT_WLAN_UPDATE_ASSOC#1,{},0,0,0,0#0,0,0,0,0,0]0,0\r\n'
                    ).format(clients_frequency),
                timeout=4)
            if not page.status_code == 200:
                print("Error %s from router", page.status_code)
                return False

            # Retrieve associated clients.
            page = requests.post(
                'http://{}/cgi?6'.format(self.host),
                headers=headers,
                data=(
                    '[LAN_WLAN_ASSOC_DEV#0,0,0,0,0,0#1,{},0,0,0,0]0,1\r\n'
                    'AssociatedDeviceMACAddress\r\n'
                    ).format(clients_frequency),
                timeout=4)
            if not page.status_code == 200:
                print("Error %s from router", page.status_code)
                return False

            mac_results.extend(self.parse_macs_colons.findall(page.text))
    
        self.last_results = mac_results
        return True

    def _update_info(self):
        if (self.jsessionId == '') or (self.token == ''):
            gotToken = self._get_auth_tokens()
            if not gotToken:
                # Retry
                print("Failed to get AuthTokens. Retrying in 3 secs.")
                time.sleep(3)
                gotToken = self._get_auth_tokens()
        else:
            gotToken = True

        if not gotToken:
            self.jsessionId = ''
            self.token = ''
            return False

        macResults = self._get_mac_results()
        if not macResults:
            self.jsessionId = ''
            self.token = ''
            return False
        print(macResults)
        return True

mr = MR6400('192.168.100.254','username','password')
mr._update_info()
